diff --git a/ArmPkg/Drivers/ArmCpuLib/ArmCortexA15Lib/ArmCortexA15Lib.c b/ArmPkg/Drivers/ArmCpuLib/ArmCortexA15Lib/ArmCortexA15Lib.c
index 2e62a4f7742f..585695a7dd5c 100644
--- a/ArmPkg/Drivers/ArmCpuLib/ArmCortexA15Lib/ArmCortexA15Lib.c
+++ b/ArmPkg/Drivers/ArmCpuLib/ArmCortexA15Lib/ArmCortexA15Lib.c
@@ -15,7 +15,7 @@
 #include <Base.h>
 #include <Library/ArmLib.h>
 #include <Library/ArmCpuLib.h>
-#include <Library/ArmArchTimerLib.h>
+#include <Library/ArmArchTimer.h>
 #include <Library/DebugLib.h>
 #include <Library/IoLib.h>
 #include <Library/PcdLib.h>
diff --git a/ArmPkg/Drivers/ArmCpuLib/ArmCortexA5xLib/ArmCortexA5xLib.c b/ArmPkg/Drivers/ArmCpuLib/ArmCortexA5xLib/ArmCortexA5xLib.c
index 99ee51fb6e2d..97f1ced41362 100644
--- a/ArmPkg/Drivers/ArmCpuLib/ArmCortexA5xLib/ArmCortexA5xLib.c
+++ b/ArmPkg/Drivers/ArmCpuLib/ArmCortexA5xLib/ArmCortexA5xLib.c
@@ -15,7 +15,7 @@
 #include <Base.h>
 #include <Library/ArmLib.h>
 #include <Library/ArmCpuLib.h>
-#include <Library/ArmArchTimerLib.h>
+#include <Library/ArmArchTimer.h>
 #include <Library/DebugLib.h>
 #include <Library/IoLib.h>
 #include <Library/PcdLib.h>
diff --git a/ArmPkg/Drivers/ArmCpuLib/ArmCortexAEMv8Lib/ArmCortexAEMv8Lib.c b/ArmPkg/Drivers/ArmCpuLib/ArmCortexAEMv8Lib/ArmCortexAEMv8Lib.c
index 3c85da616e94..3e7fa124ce48 100644
--- a/ArmPkg/Drivers/ArmCpuLib/ArmCortexAEMv8Lib/ArmCortexAEMv8Lib.c
+++ b/ArmPkg/Drivers/ArmCpuLib/ArmCortexAEMv8Lib/ArmCortexAEMv8Lib.c
@@ -14,7 +14,7 @@
 
 #include <Base.h>
 #include <Library/ArmCpuLib.h>
-#include <Library/ArmArchTimerLib.h>
+#include <Library/ArmArchTimer.h>
 #include <Library/PcdLib.h>
 
 #include <Chipset/ArmAemV8.h>
diff --git a/ArmPkg/Drivers/TimerDxe/TimerDxe.c b/ArmPkg/Drivers/TimerDxe/TimerDxe.c
index 329b085ec464..40ccf161be63 100644
--- a/ArmPkg/Drivers/TimerDxe/TimerDxe.c
+++ b/ArmPkg/Drivers/TimerDxe/TimerDxe.c
@@ -24,7 +24,7 @@
 #include <Library/UefiLib.h>
 #include <Library/PcdLib.h>
 #include <Library/IoLib.h>
-#include <Library/ArmArchTimerLib.h>
+#include <Library/ArmArchTimer.h>
 
 #include <Protocol/Timer.h>
 #include <Protocol/HardwareInterrupt.h>
diff --git a/ArmPkg/Include/Library/ArmArchTimerLib.h b/ArmPkg/Include/Library/ArmArchTimer.h
similarity index 88%
rename from ArmPkg/Include/Library/ArmArchTimerLib.h
rename to ArmPkg/Include/Library/ArmArchTimer.h
index 1ecada383b29..eb7e87d3c4fc 100644
--- a/ArmPkg/Include/Library/ArmArchTimerLib.h
+++ b/ArmPkg/Include/Library/ArmArchTimer.h
@@ -12,8 +12,8 @@
 
 **/
 
-#ifndef __ARM_ARCH_TIMER_LIB_H__
-#define __ARM_ARCH_TIMER_LIB_H__
+#ifndef __ARM_ARCH_TIMER_H__
+#define __ARM_ARCH_TIMER_H__
 
 #define ARM_ARCH_TIMER_ENABLE           (1 << 0)
 #define ARM_ARCH_TIMER_IMASK            (1 << 1)
@@ -112,4 +112,4 @@ ArmArchTimerSetCompareVal (
   IN   UINT64   Val
   );
 
-#endif // __ARM_ARCH_TIMER_LIB_H__
+#endif // __ARM_ARCH_TIMER_H__
diff --git a/ArmPkg/Library/ArmArchTimerLib/ArmArchTimerLib.c b/ArmPkg/Library/ArmArchTimerLib/ArmArchTimerLib.c
index 4fe7cb8d648f..ec4c39dbc989 100644
--- a/ArmPkg/Library/ArmArchTimerLib/ArmArchTimerLib.c
+++ b/ArmPkg/Library/ArmArchTimerLib/ArmArchTimerLib.c
@@ -20,7 +20,7 @@
 #include <Library/TimerLib.h>
 #include <Library/DebugLib.h>
 #include <Library/PcdLib.h>
-#include <Library/ArmArchTimerLib.h>
+#include <Library/ArmArchTimer.h>
 
 #define TICKS_PER_MICRO_SEC     (PcdGet32 (PcdArmArchTimerFreqInHz)/1000000U)
 
diff --git a/ArmPkg/Library/ArmLib/AArch64/AArch64ArchTimer.c b/ArmPkg/Library/ArmLib/AArch64/AArch64ArchTimer.c
index fa4f7c741b15..6a461eb2e43e 100644
--- a/ArmPkg/Library/ArmLib/AArch64/AArch64ArchTimer.c
+++ b/ArmPkg/Library/ArmLib/AArch64/AArch64ArchTimer.c
@@ -21,7 +21,7 @@
 #include <Library/DebugLib.h>
 #include "AArch64Lib.h"
 #include "ArmLibPrivate.h"
-#include <Library/ArmArchTimerLib.h>
+#include <Library/ArmArchTimer.h>
 
 VOID
 EFIAPI
diff --git a/ArmPkg/Library/ArmLib/ArmV7/ArmV7ArchTimer.c b/ArmPkg/Library/ArmLib/ArmV7/ArmV7ArchTimer.c
index 79083f56b708..bebdafce7dba 100644
--- a/ArmPkg/Library/ArmLib/ArmV7/ArmV7ArchTimer.c
+++ b/ArmPkg/Library/ArmLib/ArmV7/ArmV7ArchTimer.c
@@ -21,7 +21,7 @@
 #include <Library/DebugLib.h>
 #include "ArmV7Lib.h"
 #include "ArmLibPrivate.h"
-#include <Library/ArmArchTimerLib.h>
+#include <Library/ArmArchTimer.h>
 
 VOID
 EFIAPI